## Some vocabluary to begin with

~~~

![boring](https://media.giphy.com/media/MGmnFOZRFRo4w/giphy.gif)

~~~

## git
> Git (/ɡɪt/) is a distributed version-control system for tracking changes in
> source code during software development. It is designed for coordinating
> work among programmers, but it can be used to track changes in any set of
> files. Its goals include speed, data integrity, and support for
> distributed, non-linear workflows.

[*~wikipedia.org*](https://en.wikipedia.org/wiki/Git)

~~~

## repository
> In revision control systems, a repository is a data structure which stores
> metadata for a set of files or directory structure. [...]
> Some of the metadata that a repository contains includes, among other things:
> - A historical record of changes in the repository.
> - A set of commit objects.
> - A set of references to commit objects, called heads.

[*~wikipedia.org*](https://en.wikipedia.org/wiki/Repository_(version_control)

~~~

## commit
> In version control systems, a commit adds the latest changes to [part of]
> the source code to the repository, making these changes part of the head
> revision of the repository.

[*~wikipedia.org*](https://en.wikipedia.org/wiki/Commit_(version_control)

~~~

## head (lowercase)
> A head is simply a reference to a commit object. Each head has a name.
> By default, there is a head in every repository called master. A repository
> can contain any number of heads. At any given time, one head is selected as
> the “current head.” This head is aliased to HEAD, always in capitals.

[*~sbf5.com*](https://www.sbf5.com/~cduan/technical/git/git-1.shtml#heads)

~~~

## HEAD (uppercase)
> Note this difference: a “head” (lowercase) refers to any one of the named
> heads in the repository; “HEAD” (uppercase) refers exclusively to the
> currently active head. This distinction is used frequently in Git
> documentation. [...]

[*~sbf5.com*](https://www.sbf5.com/~cduan/technical/git/git-1.shtml#heads)

~~~

## branching
> Branching, in version control and software configuration management, is the
> duplication of an object under version control (such as a source code file or
> a directory tree) so that modifications can occur in parallel along multiple
> branches.

[*~wikipedia.org*](https://en.wikipedia.org/wiki/Branching_(version_control)

~~~

## Remotes
> As you probably know, git is a distributed version control system. Most
> operations are done locally. To communicate with the outside world, git uses
> what are called remotes. These are repositories other than the one on your
> local disk which you can push your changes into (so that other people can see
> them) or pull from (so that you can get others changes).

[*~stackoverflow.com*](https://stackoverflow.com/questions/5617211/what-is-git-remote-add-and-git-push-origin-master/5617350#5617350)

~~~

## index
![git index](https://cdn-images-1.medium.com/max/1600/1*zw0bLFWkaAP2QPfhxkoDEA.png)
